Attribute VB_Name = "modUtil"
Option Explicit

Private Const VER_PLATFORM_WIN32s = 0        'Win32s
Private Const VER_PLATFORM_WIN32_WINDOWS = 1 'Windows 95/98(?)
Private Const VER_PLATFORM_WIN32_NT = 2      'Windows NT

Private lngSectors As Long
Private IngBytes As Long
Private lngFreeClusters As Long 'gĂȂ׽
Private lngAllClusters As Long  'SĂ̸׽
Private strVolNameBuff As String * 128  'ح
Private lngVolSerlNum As Long   'حѼرް
Private lngMaxComLength As Long 'gpł̧ٖ̍ő咷
Private lngFileSysFlag As Long  '̧ټт̑
Private strFSysNameBuff As String * 128 '̧ټі

Private Type OSVERSIONINFO ' 148 bytes
  dwOSVersionInfoSize As Long     '\̻̂
  dwMajorVersion As Long          'Ҽެްޮ
  dwMinorVersion As Long          'ϲŰްޮ
  dwBuildNumber As Long           'ް
  dwPlatformId As Long            'ׯΰOS
  szCSDVersion As String * 128    'OS̒ǉ
End Type

Private Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTtoalNumberOfClusters As Long) As Long
Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpDirectoryName As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const REG_SZ = &H1

Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, ByRef phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByRef lpData As Any, ByRef lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

Public Function FreeSpace(ByRef strDrive As String) As Double
  Dim curFreeBytes As Currency, curTotalSpace As Currency, curFreeSpace As Currency
  If IsWindowsNT() Or IsOSR2() Then
    Call GetDiskFreeSpaceEx(GetDriveName(strDrive), curFreeBytes, curTotalSpace, curFreeSpace)
    FreeSpace = curFreeSpace * 10000#
  Else
    GetDiskSpace strDrive
    FreeSpace = CDbl(lngFreeClusters) * lngSectors * IngBytes
  End If
End Function

Public Function AllSpace(ByRef strDrive As String) As Double
  Dim curFreeBytes As Currency, curTotalSpace As Currency, curFreeSpace As Currency
  If IsWindowsNT() Or IsOSR2() Then
    Call GetDiskFreeSpaceEx(GetDriveName(strDrive), curFreeBytes, curTotalSpace, curFreeSpace)
    AllSpace = curTotalSpace * 10000#
  Else
    Call GetDiskFreeSpace(GetDriveName(strDrive), lngSectors, IngBytes, lngFreeClusters, lngAllClusters)
    AllSpace = CDbl(lngAllClusters) * lngSectors * IngBytes
  End If
End Function

Private Function IsOSR2() As Boolean
  Dim lngKeyHandle As Long
  Dim strBuff As String * 128
  
  Call RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", lngKeyHandle)
  Call RegQueryValueEx(lngKeyHandle, "ProductName", 0, REG_SZ, ByVal strBuff, Len(strBuff))
  Select Case GetNonNull(strBuff)
  Case "Microsoft Windows 98"
    IsOSR2 = True
  Case Else
    Call RegQueryValueEx(lngKeyHandle, "SubVersionNumber", 0, REG_SZ, ByVal strBuff, Len(strBuff))
    Select Case GetNonNull(strBuff)
    Case " B", " C"
      IsOSR2 = True
    End Select
  End Select
  Call RegCloseKey(lngKeyHandle)
End Function

Private Function IsWindowsNT() As Boolean
  Dim osvi As OSVERSIONINFO
  osvi.dwOSVersionInfoSize = Len(osvi)
  Call GetVersionEx(osvi)
  IsWindowsNT = osvi.dwPlatformId = VER_PLATFORM_WIN32_NT
End Function

Private Function GetDriveName(ByRef strDrive As String) As String
  GetDriveName = Left$(UCase$(strDrive), 1) & ":\"
End Function

Private Sub GetDiskSpace(ByRef strDrive As String)
  lngSectors = 0
  IngBytes = 0
  lngFreeClusters = 0
  lngAllClusters = 0
  Call GetDiskFreeSpace(GetDriveName(strDrive), lngSectors, IngBytes, lngFreeClusters, lngAllClusters)
End Sub

Private Function GetNonNull(str As String) As String
  On Error Resume Next
  GetNonNull = Left$(str, InStr(str, vbNullChar) - 1)
End Function

Public Function FileSizeFormat(ByVal FileSize As Variant) As String
  If IsNumeric(FileSize) Then
    If FileSize > 1024 ^ 4 * 2 Then
      FileSizeFormat = Int((FileSize / 1024 ^ 4) * 10) / 10 & "TB"
    ElseIf FileSize > 1024 ^ 3 * 2 Then
      FileSizeFormat = Int((FileSize / 1024 ^ 3) * 10) / 10 & "GB"
    ElseIf FileSize > 1024 ^ 2 * 2 Then
      FileSizeFormat = Int((FileSize / 1024 ^ 2) * 10) / 10 & "MB"
    ElseIf FileSize > 1024 Then
      FileSizeFormat = Int((FileSize / 1024) * 10) / 10 & "KB"
    Else
      FileSizeFormat = FileSize
    End If
  Else
    FileSizeFormat = FileSize
  End If
End Function
